
import java.io.*;
import javax.sound.sampled.*;


class LineOutputStream extends OutputStream {
	
	final SourceDataLine line;
	
	// Finds, opens and starts playing on a line. Caution: Trying to wrap the stream into a buffer may cause artifacts.
	LineOutputStream(AudioFormat audioFormat) throws LineUnavailableException {
		DataLine.Info info = new DataLine.Info(SourceDataLine.class, audioFormat);
		line = (SourceDataLine) AudioSystem.getLine(info);
		line.open(audioFormat); // once opened, must be closed
		line.start(); // does not produce any exceptions
	}
	
	public void write(byte[] buf, int off, int len)  {
		line.write(buf, off, len);
	}
	
	public void write(byte[] buf)  {
		write(buf, 0, buf.length);
	}
	
	public void write(int b)  {
		byte buf[] = new byte[1];
		buf[0] = (byte) b;
		write(buf);
	}
	
	/*Closes the line*/
	public void close() {
		line.close();
	}

          
}
