//import java.io.File;
import java.io.*;

public class Utils {

	public static String br() { return System.getProperty("line.separator"); }
	
	/*
	static String getExtension(String s) {
	  int i = s.lastIndexOf('.');
	  return i != -1 ? s.substring(i+1) : null;
	}
	
	static String getBase(String s) {
	  int i = s.lastIndexOf('.');
	  return i != -1 ? s.substring(0, i) : null;
	}
	*/

	
	public static double log(double base, double value) {
		return Math.log(value)/Math.log(base);
	}
	
	public static String getExtension(File f) {
        String s = f.getName();
        int i = s.lastIndexOf('.');
		return i >= 0 ? s.substring(i+1) : "";
    }

    public static String getBase(File f) {
        String s = f.getName();
        int i = s.lastIndexOf('.');
		return i >= 0 ? s.substring(0, i) : "";
    }
    
	public static boolean isInstantiable(Class clazz) {
        int mod = clazz.getModifiers();
        return !java.lang.reflect.Modifier.isAbstract(mod) && !clazz.isInterface();
    }    
    
	public static javax.swing.JRadioButton getSelectedJRadioButton(javax.swing.ButtonGroup bg){
		javax.swing.JRadioButton rb_back = null;
		javax.swing.JRadioButton rb_tmp = null;
		java.util.Enumeration e = bg.getElements(); //line 1156
		
		while (e.hasMoreElements()){
			rb_tmp = (javax.swing.JRadioButton)e.nextElement();
			if (rb_tmp.isSelected())
				rb_back = rb_tmp;
		}
		return rb_back;
	}    
	
	static String dimToStr(java.awt.Dimension d) {return d.width + "x" + d.height;}	
	
	/*public static void main(String[] args) {
		for (int i = 0; i < args.length; i++) // test parameter string: aaa . a. .a aa.a aaa.aa.a
			log( args[i] + " -> " + getBase(args[i]) + "+" + getExtension(args[i]));
			
	}*/
	
	
    public static byte[] getBytesFromFile(String filename) throws IOException {
        InputStream is = new FileInputStream(filename);
    	try {
	    	
	    	File file = new File(filename);
	        // Get the size of the file
	        long length = file.length();
	    
	        if (length > Integer.MAX_VALUE) {
	            // File is too large
	        }
	    
	        // Create the byte array to hold the data
	        byte[] result = new byte[(int)length];
	    
	        // Read in the bytes
	        int offset = 0;
	        int numRead = 0;
	        while (offset < result.length
	               && (numRead=is.read(result, offset, result.length-offset)) >= 0) {
	            offset += numRead;
	        }
	    
	        // Ensure all the bytes have been read in
	        if (offset < result.length) {
	            throw new IOException("Could not completely read the file ");
	        }
	    	
	        return result;
	        
	        // Close the input stream and return bytes
        } finally {
	        is.close();
        }
    }	
	
	public static void show(java.net.URL url) {
		System.out.println("url: authority='" + url.getAuthority() 
			+ "', file='" + url.getFile()
			+ "', host='" + url.getHost()
			+ "', path='" + url.getPath()
			+ "', port='" + url.getPort()
			+ "', protocol='" + url.getProtocol()
			+ "', query='" + url.getQuery()
			+ "', ref='" + url.getRef()
			+ "', userinfo='" + url.getUserInfo() + "'");
		
	}

}



