import javax.swing.event.*;

/**Plain implementation returns ordinate value/domain. The value domain is natural; i.e. it
is ordinal domain limited.

The translation errors may pose problems. That is, Inverse(Direct(val)) != val. */
public class Function implements FloatBoundedRangeModel {
	
	/**Defines ordinate along with its domain.*/
	FloatBoundedRangeModel ordinate;
	
	public Function(FloatBoundedRangeModel ordinate) {
		this.ordinate = ordinate;
	}
	
	public FloatBoundedRangeModel getOrdinateModel() { return ordinate; }
		
	/**Direct transform*/
	protected float getValue(float ordinate) {
		return ordinate;
	}
	
	/**Inverse transform*/
	protected float getOrdinate(float value) {
		return value;
	}
	
	/**Plain implementation returns ordinate value/domain*/
	public float getValue() { return getValue(ordinate.getValue()); }
	public void setValue(float val) { 
		ordinate.setValue(getOrdinate(val));
	}
	
	/**What if and the extent is therefore negative doe to declaining function? */
	public float getExtent() { return getValue(ordinate.getValue()) - getValue(ordinate.getValue() + ordinate.getExtent()); }
	public void setExtent(float ext) { 
		ordinate.setExtent(getOrdinate(getValue() + ext) - getOrdinate(getValue()));
	}
	
	public float getMinimum() { return getValue(ordinate.getMinimum()); }
	public void setMinimum(float min) {
		ordinate.setMinimum(getOrdinate(min));
	}
	
	public float getMaximum() { return getValue(ordinate.getMaximum()); }
	public void setMaximum(float max) {
		ordinate.setMaximum(getOrdinate(max));
	}
	
    public void setValueIsAdjusting(boolean b) {
	    ordinate.setValueIsAdjusting(b);
    }

    public boolean getValueIsAdjusting() {
	    return ordinate.getValueIsAdjusting();
    }
    
    public void setRangeProperties(float value, float extent, float min, float max, boolean adjusting) {
	    ordinate.setRangeProperties(
	    	getOrdinate(value),
	    	getOrdinate(value + extent) - getOrdinate(value),
	    	getOrdinate(min),
	    	getOrdinate(max),
	    	adjusting);
    }
	
    public void addChangeListener(ChangeListener l) {
		ordinate.addChangeListener(l);
	}
	
	public void removeChangeListener(ChangeListener l) {
		ordinate.removeChangeListener(l);
	}
	
    public String toString()  {
        String modelString =
        	getValue() + "+" + getExtent() + " in (" + getMinimum() + ", " + getMaximum() + "), " + 
            "odinate=[" + ordinate + "]";

        return getClass().getName() + "[" + modelString + "]";
    }
}