import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import javax.swing.event.*;
import javax.swing.text.NumberFormatter;
import java.beans.*;

/*
 * SliderDemo3.java requires all the files in the images/doggy
 * directory.  It adds a formatted text field to SliderDemo.java.
 */
public class SliderDemo3 extends JPanel {

	
    //Add a formatted text field to supplement the slider.
    final JTextField textField = new JTextField(5);

    //And here's the slider.
    final JSlider slider;
    
    /*
	private final static float MIN = -1;
	private final static float MAX = .9f;
    final FloatBoundedRangeModel model = RoundFloatBoundedRangeModel(0f, MIN, MAX);
    */
    
    final int GRADES = 100;
    final FloatBoundedRangeModel model = 
    	new LogBoundedRangeModel(
    //		(float) Math.pow(10000, 1/(double)GRADES), 1f, 0f, 0, GRADES);
    		(float) Math.pow(10000, 1/(double)GRADES), 1f, 0f, 0, GRADES, 0, 10000);

    public SliderDemo3() {
        setLayout(new BoxLayout(this, BoxLayout.PAGE_AXIS));

        //Create the slider.
        slider = new JSlider(); // cannot use JSlider(model constructor)
        slider.addChangeListener(new ChangeListener() {
		    public void stateChanged(ChangeEvent e) {
	       		System.out.println("onSlider, adjusting = " + slider.getValueIsAdjusting() + ", fval = " + model.getFloatValue());
	       		textField.setText(model.getFloatValue()+"");
		    }
        });
        slider.setModel(model);

        model.addChangeListener(new ChangeListener() {
		    public void stateChanged(ChangeEvent e) {
		        System.out.println("onModel" + ", intVal = " + model.getValue() + ", floatVal = " + model.getFloatValue());
		    }
        });
        
		textField.addActionListener(new ActionListener() {
		    public void actionPerformed(ActionEvent e) {
		   		//System.out.println("onEnter");
		   		try {
		   			model.setFloatValue(Float.parseFloat(textField.getText()));
	   			} catch (NumberFormatException ex) {System.out.println("Bad float format");}
		    }
		});
        
        //Put everything together.
        add(textField);
        add(slider);
        
        
    }




    /**
     * Create the GUI and show it.  For thread safety,
     * this method should be invoked from the
     * event-dispatching thread.
     */
    private static void createAndShowGUI() {
        //Create and set up the window.
        JFrame frame = new JFrame("SliderDemo3");
        frame.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

        //Create and set up the content pane.
        SliderDemo3 animator = new SliderDemo3();
        animator.setOpaque(true); //content panes must be opaque
        frame.setContentPane(animator);

        //Display the window.
        frame.pack();
        frame.setVisible(true);
    }

    public static void main(String[] args) {
        //Schedule a job for the event-dispatching thread:
        //creating and showing this application's GUI.
        javax.swing.SwingUtilities.invokeLater(new Runnable() {
            public void run() {
                createAndShowGUI();
            }
        });
    }
}
