
//import floatmodel.*;

import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*;
import javax.swing.event.*;


class TitleEditDemo implements Runnable {

	public void run() { 
	
		// create the window
		final FloatTitleEditFrame frame = new FloatTitleEditFrame();
		
		IntFloatBoundedRangeAdapter linModel = new IntFloatBoundedRangeAdapter(new DefaultFloatBoundedRangeModel(0f, (float) -Math.PI, (float) +Math.PI), 30);
		//IntFloatBoundedRangeAdapter linModel = new IntFloatBoundedRangeAdapter(new DefaultFloatBoundedRangeModel(0f, 0, 2), 3);
		final int GRADES = 100;
		IntFloatBoundedRangeAdapter logModel = new IntFloatLogAdapter(new DefaultFloatBoundedRangeModel(440, 0, 10000), GRADES, (float) Math.pow(10000, 1/(double)(GRADES-1)), 1f, 0f);
		
		
		// linear slider
		final JSlider sl1 = frame.new Slider(linModel, "Manual ampl = ") {
			public String formatValue() {
				return "ampl = " + getFloatValue();
			}
		};

		//make sure that our games with key listening do not affect the expected 
		//behaviour
// 		sl1.addKeyListener(	new KeyAdapter() {
// 	 		public void keyTyped(KeyEvent e) {
// 		 		System.out.println("Typed '" + e.getKeyChar() + "'");
// 			}
// 		});

		
		// logarithmic slider
		final JSlider sl2 = frame.new Slider(logModel, "Manual freq = ") {
			public String formatValue() {
				return "Freq = " + getFloatValue() + " Hz";
			}
		};
		
				
		ChangeListener cl = new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				System.out.println("changed to " + ((FloatTitleEditFrame.Slider) e.getSource()).getFloatValue());
			}
		};
		
		sl1.addChangeListener(cl);
		sl2.addChangeListener(cl);
		frame.getContentPane().add(sl1, BorderLayout.NORTH);
		frame.getContentPane().add(sl2, BorderLayout.CENTER); 

		//the automatic focus removes the default frame title.
		//sl1.setFocusable(false);
		//sl2.setFocusable(false);
		
				
		//Display the window. 
		frame.pack(); 
		frame.setVisible(true);
		frame.setTitle("TopLevelDemo");
	}

		
	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new TitleEditDemo()); 
	}

		
}
