import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*;
import javax.swing.event.*;

class TitleEditDemo implements Runnable {

	public void run() { 
	
		// create the window
		final FloatTitleEditFrame frame = new FloatTitleEditFrame("TopLevelDemo");
		
		final FloatBoundedRangeModel linModel = new DefaultFloatBoundedRangeModel();
		final FloatBoundedRangeModel logModel;
		{
		    final int GRADES = 100;
		    logModel = new LogBoundedRangeModel((float) Math.pow(10000, 1/(double)GRADES), 1f, 0f, 0, GRADES, 0, 10000);
		}
		
		// linear slider
		final JSlider sl1 = new JSlider();
		final JSlider sl2 = new JSlider();
		
		sl1.setModel(linModel);
		sl2.setModel(logModel);
		
		frame.new EditableModelWrapper(linModel, "Manual ampl = ", sl1) {
			public String formatValue() {
				return "ampl = " + model.getFloatValue();
			}
		};

		frame.new EditableModelWrapper(logModel, "Manual freq = ", sl2) {
			public String formatValue() {
				return "Freq = " + model.getFloatValue() + " Hz";
			}
		};
				
		ChangeListener cl = new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				System.out.println("changed to " + ((FloatBoundedRangeModel) (((JSlider) e.getSource()).getModel())).getFloatValue());
			}
		};
		
		sl1.addChangeListener(cl);
		sl2.addChangeListener(cl);
		frame.getContentPane().add(sl1, BorderLayout.NORTH);
		frame.getContentPane().add(sl2, BorderLayout.CENTER); 
		
		//Display the window. 
		frame.pack(); 
		frame.setVisible(true);
	
	}

		
	public static void main(String[] args) {
		javax.swing.SwingUtilities.invokeLater(new TitleEditDemo()); 
	}

		
}
